## redis 4.0.6

=== debian/changelog ===
redis (5:4.0.6-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Chris Lamb <lamby@debian.org>  Tue, 05 Dec 2017 13:00:47 +0000

redis (5:4.0.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Use "metapackage" over "meta-package".
  * debian/patches:
    - Drop 0008-CVE-2017-15047-Fix-buffer-overflows-occurring-readin.
    - Refresh.

 -- Chris Lamb <lamby@debian.org>  Sat, 02 Dec 2017 18:54:58 +0000

redis (4:4.0.2-9) unstable; urgency=medium

  * Also update aof.c for MAXPATHLEN issues. (Closes: #881684)

 -- Chris Lamb <lamby@debian.org>  Thu, 16 Nov 2017 10:21:37 +0900

redis (4:4.0.2-8) unstable; urgency=medium

  * Use get_current_dir_name over PATHMAX, etc. (Closes: #881684)
  * Don't rely on taskset existing for kFreeBSD-*. (Closes: #881683)
  * Drop "memory efficiency" tests on advice from upstream. (Closes: #881682)
  * Correct BSD-3-clause -> BSD-2-clause for Marc Alexander Lehmann's
    attribution in debian/copyright.
  * Let package be bin-NMUable.

 -- Chris Lamb <lamby@debian.org>  Thu, 16 Nov 2017 03:50:00 +0900

redis (4:4.0.2-7) unstable; urgency=medium

  * Add a "redis" metapackage. (Closes: #876475)
  * Drop conditionally exporting FORCE_LIBC_MALLOC; upstreamed since 2.6.0-1.

 -- Chris Lamb <lamby@debian.org>  Sun, 12 Nov 2017 08:54:24 +0000

redis (4:4.0.2-6) unstable; urgency=medium

  * Correct locations of redis-sentinel pidfiles. Thanks to Nicolas Payart for
    the patch. (Closes: #880980)

 -- Chris Lamb <lamby@debian.org>  Mon, 06 Nov 2017 22:02:19 +0000

redis (4:4.0.2-5) unstable; urgency=medium

  * CVE-2017-15047: Replace existing patch with upstream-blessed version that
    covers another case. (Closes: #878076)

 -- Chris Lamb <lamby@debian.org>  Tue, 31 Oct 2017 11:13:40 +0100

redis (4:4.0.2-4) unstable; urgency=medium

  * CVE-2017-15047: Add input validity checking to redis cluster config slot
    numbers. (Closes: #878076)
  * Drop debian/bin/generate-parts script now we aren't calling it.
  * Correct Bash-esque in NEWS.
  * Upstream are not providing signed tarballs, so ignore the
    "debian-watch-may-check-gpg-signature" Lintian tag,
  * Drop trailing whitespace in debian/changelog.
  * Use HTTPS URI in debian/watch.

 -- Chris Lamb <lamby@debian.org>  Mon, 30 Oct 2017 10:32:04 +0000

redis (4:4.0.2-3) unstable; urgency=medium

  * Drop Debian-specific support for
    /etc/redis/redis-{server,sentinel}.{pre,post}-{up,down}.d and remove them
    if unchanged.
  * Include systemd redis-server@.service and redis-sentinel@.service template
    files to easily run multiple instances. (Closes: #877702)
  * Patch redis.conf and sentinel.conf with quilt instead of maintaining our
    own versions under debian/.
  * Refresh all patches.
  * Bump Standards-Version to 4.1.1.

 -- Chris Lamb <lamby@debian.org>  Thu, 12 Oct 2017 14:54:27 -0400

redis (4:4.0.2-2) unstable; urgency=medium

  * Update 0004-redis-check-rdb test to ensure that redis.rdb exists before
    testing it.

 -- Chris Lamb <lamby@debian.org>  Mon, 25 Sep 2017 10:16:18 +0100

redis (4:4.0.2-1) unstable; urgency=medium

  * New upstream release ("Upgrade urgency HIGH: Several potentially critical
    bugs fixed.")
  * Bump Standards-Version to 4.1.0.
  * Drop Build-Depends on dh-systemd (>= 1.5).

 -- Chris Lamb <lamby@debian.org>  Sun, 24 Sep 2017 19:46:10 +0100

=== debian/control ===
Source: redis
Section: database
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper (>= 10.9.1),
 dpkg-dev (>= 1.17.14),
 libjemalloc-dev [linux-any],
 procps <!nocheck>,
 tcl <!nocheck>,
Standards-Version: 4.1.1
Homepage: http://redis.io/
Vcs-Git: https://github.com/lamby/pkg-redis.git
Vcs-Browser: https://github.com/lamby/pkg-redis

Package: redis
Architecture: all
Depends:
 redis-server (<< ${binary:Version}.1~),
 redis-server (>= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (metapackage)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.
 .
 This package depends on the redis-server package.

Package: redis-server
Architecture: any
Depends:
 adduser,
 lsb-base (>= 3.2-14),
 redis-tools (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Persistent key-value database with network interface
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: redis-tools
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 ruby-redis
Replaces:
 redis-server (<< 2:2.6.16-1)
Breaks:
 redis-server (<< 2:2.6.16-1)
Description: Persistent key-value database with network interface (client)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.

Package: redis-sentinel
Architecture: any
Depends:
 lsb-base (>= 3.2-14),
 redis-server (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: Persistent key-value database with network interface (monitoring)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the Redis Sentinel monitoring software.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk

export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -ldl -latomic

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	export MAKEFLAGS
endif

%:
	dh $@ --with systemd

override_dh_auto_install:
	debian/bin/generate-systemd-service-files

override_dh_auto_build:
	dh_auto_build --parallel -- V=1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(wildcard /usr/bin/taskset),)
	# Avoid race conditions in upstream testsuite. (#830500)
	taskset --cpu-list 0 ./runtest
	# Sentinel integration tests use too many timers to be reliable or
	# meaningful.
	taskset --cpu-list 0 ./runtest-sentinel || true
endif
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/release.h debian/*.service

override_dh_compress:
	dh_compress -Xredis-trib.rb

override_dh_installchangelogs:
	dh_installchangelogs --keep 00-RELEASENOTES

## redis 4.0.7

=== debian/changelog ===
redis (5:4.0.7-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Mon, 29 Jan 2018 16:45:14 +0000

redis (5:4.0.7-1) unstable; urgency=medium

  * New upstream release.
    <https://groups.google.com/forum/#!topic/redis-db/gngqHoh-kRM>
  * Refresh patches.

 -- Chris Lamb <lamby@debian.org>  Wed, 24 Jan 2018 22:10:06 +1100

redis (5:4.0.6-5) unstable; urgency=medium

  * Update redis-sentinel's symlink to usr/bin/redis-check-rdb to match
    redis-server. This avoids a dangling symlink (and thus a broken package) if
    redis-server is not installed. (Closes: #884321)
  * Move to debhelper compat level 11.
    - Drop reference to --with=systemd - systemd-sequence is no longer provided
      in compat >= 11.
  * Use https URI for copyright format specification in debian/copyright.

 -- Chris Lamb <lamby@debian.org>  Sat, 20 Jan 2018 11:21:11 +1100

redis (5:4.0.6-4) unstable; urgency=medium

  * Re-add procps to Build-Depends. (Closes: #887075)

 -- Chris Lamb <lamby@debian.org>  Sat, 13 Jan 2018 19:01:56 +0530

redis (5:4.0.6-3) unstable; urgency=medium

  * Use --clients argument to runtest to force single-threaded operation over
    using taskset.
  * Bump Standards-Version to 4.1.3.

 -- Chris Lamb <lamby@debian.org>  Sat, 13 Jan 2018 12:55:27 +0530

redis (5:4.0.6-2) unstable; urgency=medium

  * Replace redis-sentinel's main dependency with redis-tools from
    redis-server, necessarily moving the creating/deletion of the "redis" user
    and associated data and log directories to redis-tools. (Closes: #884321)
  * Add stub manpages for redis-sentinel, redis-check-aof and redis-check-rdb.
  * Bump Standards-Version to 4.1.2.

 -- Chris Lamb <lamby@debian.org>  Thu, 14 Dec 2017 10:08:30 +0000

redis (5:4.0.6-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Sun, 10 Dec 2017 10:19:12 +0000

redis (4:4.0.2-9~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 29 Nov 2017 15:37:35 +0900

redis (4:4.0.2-6~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Mon, 06 Nov 2017 22:11:38 +0000

redis (4:4.0.2-5~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Sun, 05 Nov 2017 09:22:19 +0000

redis (4:4.0.2-3~bpo9+2) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
    - Relax debhelper Build-Depends to become satisfiable in
      stretch-backports.
  * Update debian/gbp.conf to reflect backports debian-branch.

 -- Chris Lamb <lamby@debian.org>  Wed, 18 Oct 2017 08:26:05 -0400

redis (4:4.0.2-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 18 Oct 2017 07:58:46 -0400

redis (4:4.0.2-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Sat, 30 Sep 2017 10:03:10 +0100

redis (4:4.0.1-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Fri, 11 Aug 2017 10:35:20 -0400

redis (3:3.2.9-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 26 Jul 2017 19:53:36 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,12 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 10.9.1),
+ debhelper (>= 10),
  dpkg-dev (>= 1.17.14),
  libjemalloc-dev [linux-any],
  procps <!nocheck>,
  tcl <!nocheck>,
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 Homepage: http://redis.io/
 Vcs-Git: https://github.com/lamby/pkg-redis.git
 Vcs-Browser: https://github.com/lamby/pkg-redis
@@ -31,7 +31,6 @@
 Package: redis-server
 Architecture: any
 Depends:
- adduser,
  lsb-base (>= 3.2-14),
  redis-tools (= ${binary:Version}),
  ${misc:Depends},
@@ -47,7 +46,8 @@
 Architecture: any
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
+ adduser,
 Suggests:
  ruby-redis
 Replaces:
@@ -65,7 +65,7 @@
 Architecture: any
 Depends:
  lsb-base (>= 3.2-14),
- redis-server (= ${binary:Version}),
+ redis-tools (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
 Description: Persistent key-value database with network interface (monitoring)

## redis 4.0.8

=== debian/changelog ===
redis (5:4.0.8-2) unstable; urgency=medium

  * Also listen on ::1 for IPv6 by default. (Closes: #891432)

 -- Chris Lamb <lamby@debian.org>  Sun, 25 Feb 2018 14:59:55 +0000

redis (5:4.0.8-1) unstable; urgency=medium

  * New upstream release.
    <https://groups.google.com/forum/#!topic/redis-db/FGplxMEGEMo>
  * Update lintian overrides after rename of
    debian-watch-may-check-gpg-signature →
    debian-watch-does-not-check-gpg-signature.
  * Drop "recursive" argument to chown in postinst script to prevent hardlink
    vulnerability.

 -- Chris Lamb <lamby@debian.org>  Mon, 05 Feb 2018 17:09:44 +0000

## redis 4.0.9

=== deps/Makefile ===
# Redis dependency Makefile

uname_S:= $(shell sh -c 'uname -s 2>/dev/null || echo not')

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

default:
	@echo "Explicit target required"

.PHONY: default

# Prerequisites target
.make-prerequisites:
	@touch $@

# Clean everything when CFLAGS is different
ifneq ($(shell sh -c '[ -f .make-cflags ] && cat .make-cflags || echo none'), $(CFLAGS))
.make-cflags: distclean
	-(echo "$(CFLAGS)" > .make-cflags)
.make-prerequisites: .make-cflags
endif

# Clean everything when LDFLAGS is different
ifneq ($(shell sh -c '[ -f .make-ldflags ] && cat .make-ldflags || echo none'), $(LDFLAGS))
.make-ldflags: distclean
	-(echo "$(LDFLAGS)" > .make-ldflags)
.make-prerequisites: .make-ldflags
endif

distclean:
	-(cd hiredis && $(MAKE) clean) > /dev/null || true
	-(cd linenoise && $(MAKE) clean) > /dev/null || true
	-(cd lua && $(MAKE) clean) > /dev/null || true
	-(cd jemalloc && [ -f Makefile ] && $(MAKE) distclean) > /dev/null || true
	-(rm -f .make-*)

.PHONY: distclean

hiredis: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd hiredis && $(MAKE) static

.PHONY: hiredis

linenoise: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd linenoise && $(MAKE)

.PHONY: linenoise

ifeq ($(uname_S),SunOS)
	# Make isinf() available
	LUA_CFLAGS= -D__C99FEATURES__=1
endif

LUA_CFLAGS+= -O2 -Wall -DLUA_ANSI -DENABLE_CJSON_GLOBAL -DREDIS_STATIC='' $(CFLAGS)
LUA_LDFLAGS+= $(LDFLAGS)
# lua's Makefile defines AR="ar rcu", which is unusual, and makes it more
# challenging to cross-compile lua (and redis).  These defines make it easier
# to fit redis into cross-compilation environments, which typically set AR.
AR=ar
ARFLAGS=rcu

lua: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd lua/src && $(MAKE) all CFLAGS="$(LUA_CFLAGS)" MYLDFLAGS="$(LUA_LDFLAGS)" AR="$(AR) $(ARFLAGS)"

.PHONY: lua

JEMALLOC_CFLAGS= -std=gnu99 -Wall -pipe -g3 -O3 -funroll-loops $(CFLAGS)
JEMALLOC_LDFLAGS= $(LDFLAGS)

jemalloc: .make-prerequisites
	@printf '%b %b\n' $(MAKECOLOR)MAKE$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR)
	cd jemalloc && ./configure --with-lg-quantum=3 --with-jemalloc-prefix=je_ --enable-cc-silence CFLAGS="$(JEMALLOC_CFLAGS)" LDFLAGS="$(JEMALLOC_LDFLAGS)"
	cd jemalloc && $(MAKE) CFLAGS="$(JEMALLOC_CFLAGS)" LDFLAGS="$(JEMALLOC_LDFLAGS)" lib/libjemalloc.a

.PHONY: jemalloc

=== src/Makefile ===
# Redis Makefile
# Copyright (C) 2009 Salvatore Sanfilippo <antirez at gmail dot com>
# This file is released under the BSD license, see the COPYING file
#
# The Makefile composes the final FINAL_CFLAGS and FINAL_LDFLAGS using
# what is needed for Redis plus the standard CFLAGS and LDFLAGS passed.
# However when building the dependencies (Jemalloc, Lua, Hiredis, ...)
# CFLAGS and LDFLAGS are propagated to the dependencies, so to pass
# flags only to be used when compiling / linking Redis itself REDIS_CFLAGS
# and REDIS_LDFLAGS are used instead (this is the case of 'make gcov').
#
# Dependencies are stored in the Makefile.dep file. To rebuild this file
# Just use 'make dep', but this is only needed by developers.

release_hdr := $(shell sh -c './mkreleasehdr.sh')
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
uname_M := $(shell sh -c 'uname -m 2>/dev/null || echo not')
OPTIMIZATION?=-O2
DEPENDENCY_TARGETS=hiredis linenoise lua
NODEPS:=clean distclean

# Default settings
STD=-std=c99 -pedantic -DREDIS_STATIC=''
WARN=-Wall -W -Wno-missing-field-initializers
OPT=$(OPTIMIZATION)

PREFIX?=/usr/local
INSTALL_BIN=$(PREFIX)/bin
INSTALL=install

# Default allocator defaults to Jemalloc if it's not an ARM
MALLOC=libc
ifneq ($(uname_M),armv6l)
ifneq ($(uname_M),armv7l)
ifeq ($(uname_S),Linux)
	MALLOC=jemalloc
endif
endif
endif

# To get ARM stack traces if Redis crashes we need a special C flag.
ifneq (,$(findstring armv,$(uname_M)))
        CFLAGS+=-funwind-tables
endif

# Backwards compatibility for selecting an allocator
ifeq ($(USE_TCMALLOC),yes)
	MALLOC=tcmalloc
endif

ifeq ($(USE_TCMALLOC_MINIMAL),yes)
	MALLOC=tcmalloc_minimal
endif

ifeq ($(USE_JEMALLOC),yes)
	MALLOC=jemalloc
endif

ifeq ($(USE_JEMALLOC),no)
	MALLOC=libc
endif

# Override default settings if possible
-include .make-settings

FINAL_CFLAGS=$(STD) $(WARN) $(OPT) $(DEBUG) $(CFLAGS) $(REDIS_CFLAGS)
FINAL_LDFLAGS=$(LDFLAGS) $(REDIS_LDFLAGS) $(DEBUG)
FINAL_LIBS=-lm
DEBUG=-g -ggdb

ifeq ($(uname_S),SunOS)
	# SunOS
        ifneq ($(@@),32bit)
		CFLAGS+= -m64
		LDFLAGS+= -m64
	endif
	DEBUG=-g
	DEBUG_FLAGS=-g
	export CFLAGS LDFLAGS DEBUG DEBUG_FLAGS
	INSTALL=cp -pf
	FINAL_CFLAGS+= -D__EXTENSIONS__ -D_XPG6
	FINAL_LIBS+= -ldl -lnsl -lsocket -lresolv -lpthread -lrt
else
ifeq ($(uname_S),Darwin)
	# Darwin
	FINAL_LIBS+= -ldl
else
ifeq ($(uname_S),AIX)
        # AIX
        FINAL_LDFLAGS+= -Wl,-bexpall
        FINAL_LIBS+=-ldl -pthread -lcrypt -lbsd
else
ifeq ($(uname_S),OpenBSD)
	# OpenBSD
	FINAL_LIBS+= -lpthread
else
ifeq ($(uname_S),FreeBSD)
	# FreeBSD
	FINAL_LIBS+= -lpthread
else
	# All the other OSes (notably Linux)
	FINAL_LDFLAGS+= -rdynamic
	FINAL_LIBS+=-ldl -pthread
endif
endif
endif
endif
endif
# Include paths to dependencies
FINAL_CFLAGS+= -I../deps/hiredis -I../deps/linenoise -I../deps/lua/src

ifeq ($(MALLOC),tcmalloc)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc
endif

ifeq ($(MALLOC),tcmalloc_minimal)
	FINAL_CFLAGS+= -DUSE_TCMALLOC
	FINAL_LIBS+= -ltcmalloc_minimal
endif

ifeq ($(MALLOC),jemalloc)
	DEPENDENCY_TARGETS+= jemalloc
	FINAL_CFLAGS+= -DUSE_JEMALLOC -I../deps/jemalloc/include
	FINAL_LIBS+= ../deps/jemalloc/lib/libjemalloc.a
endif

REDIS_CC=$(QUIET_CC)$(CC) $(FINAL_CFLAGS)
REDIS_LD=$(QUIET_LINK)$(CC) $(FINAL_LDFLAGS)
REDIS_INSTALL=$(QUIET_INSTALL)$(INSTALL)

CCCOLOR="\033[34m"
LINKCOLOR="\033[34;1m"
SRCCOLOR="\033[33m"
BINCOLOR="\033[37;1m"
MAKECOLOR="\033[32;1m"
ENDCOLOR="\033[0m"

ifndef V
QUIET_CC = @printf '    %b %b\n' $(CCCOLOR)CC$(ENDCOLOR) $(SRCCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_LINK = @printf '    %b %b\n' $(LINKCOLOR)LINK$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
QUIET_INSTALL = @printf '    %b %b\n' $(LINKCOLOR)INSTALL$(ENDCOLOR) $(BINCOLOR)$@$(ENDCOLOR) 1>&2;
endif

REDIS_SERVER_NAME=redis-server
REDIS_SENTINEL_NAME=redis-sentinel
REDIS_SERVER_OBJ=adlist.o quicklist.o ae.o anet.o dict.o server.o sds.o zmalloc.o lzf_c.o lzf_d.o pqsort.o zipmap.o sha1.o ziplist.o release.o networking.o util.o object.o db.o replication.o rdb.o t_string.o t_list.o t_set.o t_zset.o t_hash.o config.o aof.o pubsub.o multi.o debug.o sort.o intset.o syncio.o cluster.o crc16.o endianconv.o slowlog.o scripting.o bio.o rio.o rand.o memtest.o crc64.o bitops.o sentinel.o notify.o setproctitle.o blocked.o hyperloglog.o latency.o sparkline.o redis-check-rdb.o redis-check-aof.o geo.o lazyfree.o module.o evict.o expire.o geohash.o geohash_helper.o childinfo.o defrag.o siphash.o rax.o
REDIS_CLI_NAME=redis-cli
REDIS_CLI_OBJ=anet.o adlist.o redis-cli.o zmalloc.o release.o anet.o ae.o crc64.o
REDIS_BENCHMARK_NAME=redis-benchmark
REDIS_BENCHMARK_OBJ=ae.o anet.o redis-benchmark.o adlist.o zmalloc.o redis-benchmark.o
REDIS_CHECK_RDB_NAME=redis-check-rdb
REDIS_CHECK_AOF_NAME=redis-check-aof

all: $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_RDB_NAME) $(REDIS_CHECK_AOF_NAME)
	@echo ""
	@echo "Hint: It's a good idea to run 'make test' ;)"
	@echo ""

Makefile.dep:
	-$(REDIS_CC) -MM *.c > Makefile.dep 2> /dev/null || true

ifeq (0, $(words $(findstring $(MAKECMDGOALS), $(NODEPS))))
-include Makefile.dep
endif

.PHONY: all

persist-settings: distclean
	echo STD=$(STD) >> .make-settings
	echo WARN=$(WARN) >> .make-settings
	echo OPT=$(OPT) >> .make-settings
	echo MALLOC=$(MALLOC) >> .make-settings
	echo CFLAGS=$(CFLAGS) >> .make-settings
	echo LDFLAGS=$(LDFLAGS) >> .make-settings
	echo REDIS_CFLAGS=$(REDIS_CFLAGS) >> .make-settings
	echo REDIS_LDFLAGS=$(REDIS_LDFLAGS) >> .make-settings
	echo PREV_FINAL_CFLAGS=$(FINAL_CFLAGS) >> .make-settings
	echo PREV_FINAL_LDFLAGS=$(FINAL_LDFLAGS) >> .make-settings
	-(cd ../deps && $(MAKE) $(DEPENDENCY_TARGETS))

.PHONY: persist-settings

# Prerequisites target
.make-prerequisites:
	@touch $@

# Clean everything, persist settings and build dependencies if anything changed
ifneq ($(strip $(PREV_FINAL_CFLAGS)), $(strip $(FINAL_CFLAGS)))
.make-prerequisites: persist-settings
endif

ifneq ($(strip $(PREV_FINAL_LDFLAGS)), $(strip $(FINAL_LDFLAGS)))
.make-prerequisites: persist-settings
endif

# redis-server
$(REDIS_SERVER_NAME): $(REDIS_SERVER_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/lua/src/liblua.a $(FINAL_LIBS)

# redis-sentinel
$(REDIS_SENTINEL_NAME): $(REDIS_SERVER_NAME)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME)

# redis-check-rdb
$(REDIS_CHECK_RDB_NAME): $(REDIS_SERVER_NAME)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_CHECK_RDB_NAME)

# redis-check-aof
$(REDIS_CHECK_AOF_NAME): $(REDIS_SERVER_NAME)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(REDIS_CHECK_AOF_NAME)

# redis-cli
$(REDIS_CLI_NAME): $(REDIS_CLI_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a ../deps/linenoise/linenoise.o $(FINAL_LIBS)

# redis-benchmark
$(REDIS_BENCHMARK_NAME): $(REDIS_BENCHMARK_OBJ)
	$(REDIS_LD) -o $@ $^ ../deps/hiredis/libhiredis.a $(FINAL_LIBS)

dict-benchmark: dict.c zmalloc.c sds.c siphash.c
	$(REDIS_CC) $(FINAL_CFLAGS) $^ -D DICT_BENCHMARK_MAIN -o $@ $(FINAL_LIBS)

# Because the jemalloc.h header is generated as a part of the jemalloc build,
# building it should complete before building any other object. Instead of
# depending on a single artifact, build all dependencies first.
%.o: %.c .make-prerequisites
	$(REDIS_CC) -c $<

clean:
	rm -rf $(REDIS_SERVER_NAME) $(REDIS_SENTINEL_NAME) $(REDIS_CLI_NAME) $(REDIS_BENCHMARK_NAME) $(REDIS_CHECK_RDB_NAME) $(REDIS_CHECK_AOF_NAME) *.o *.gcda *.gcno *.gcov redis.info lcov-html Makefile.dep dict-benchmark

.PHONY: clean

distclean: clean
	-(cd ../deps && $(MAKE) distclean)
	-(rm -f .make-*)

.PHONY: distclean

test: $(REDIS_SERVER_NAME) $(REDIS_CHECK_AOF_NAME)
	@(cd ..; ./runtest)

test-sentinel: $(REDIS_SENTINEL_NAME)
	@(cd ..; ./runtest-sentinel)

check: test

lcov:
	$(MAKE) gcov
	@(set -e; cd ..; ./runtest --clients 1)
	@geninfo -o redis.info .
	@genhtml --legend -o lcov-html redis.info

test-sds: sds.c sds.h
	$(REDIS_CC) sds.c zmalloc.c -DSDS_TEST_MAIN $(FINAL_LIBS) -o /tmp/sds_test
	/tmp/sds_test

.PHONY: lcov

bench: $(REDIS_BENCHMARK_NAME)
	./$(REDIS_BENCHMARK_NAME)

32bit:
	@echo ""
	@echo "WARNING: if it fails under Linux you probably need to install libc6-dev-i386"
	@echo ""
	$(MAKE) CFLAGS="-m32" LDFLAGS="-m32"

gcov:
	$(MAKE) REDIS_CFLAGS="-fprofile-arcs -ftest-coverage -DCOVERAGE_TEST" REDIS_LDFLAGS="-fprofile-arcs -ftest-coverage"

noopt:
	$(MAKE) OPTIMIZATION="-O0"

valgrind:
	$(MAKE) OPTIMIZATION="-O0" MALLOC="libc"

helgrind:
	$(MAKE) OPTIMIZATION="-O0" MALLOC="libc" CFLAGS="-D__ATOMIC_VAR_FORCE_SYNC_MACROS"

src/help.h:
	@../utils/generate-command-help.rb > help.h

install: all
	@mkdir -p $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_SERVER_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_BENCHMARK_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CLI_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CHECK_RDB_NAME) $(INSTALL_BIN)
	$(REDIS_INSTALL) $(REDIS_CHECK_AOF_NAME) $(INSTALL_BIN)
	@ln -sf $(REDIS_SERVER_NAME) $(INSTALL_BIN)/$(REDIS_SENTINEL_NAME)

=== src/modules/Makefile ===

# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

# Compile flags for linux / osx
ifeq ($(uname_S),Linux)
	SHOBJ_CFLAGS ?= -W -Wall -fno-common -g -ggdb -std=c99 -O2
	SHOBJ_LDFLAGS ?= -shared
else
	SHOBJ_CFLAGS ?= -W -Wall -dynamic -fno-common -g -ggdb -std=c99 -O2
	SHOBJ_LDFLAGS ?= -bundle -undefined dynamic_lookup
endif

.SUFFIXES: .c .so .xo .o

all: helloworld.so hellotype.so helloblock.so testmodule.so

.c.xo:
	$(CC) -I. $(CFLAGS) $(SHOBJ_CFLAGS) -fPIC -c $< -o $@

helloworld.xo: ../redismodule.h

helloworld.so: helloworld.xo
	$(LD) -o $@ $< $(SHOBJ_LDFLAGS) $(LIBS) -lc

hellotype.xo: ../redismodule.h

hellotype.so: hellotype.xo
	$(LD) -o $@ $< $(SHOBJ_LDFLAGS) $(LIBS) -lc

helloblock.xo: ../redismodule.h

helloblock.so: helloblock.xo
	$(LD) -o $@ $< $(SHOBJ_LDFLAGS) $(LIBS) -lpthread -lc

testmodule.xo: ../redismodule.h

testmodule.so: testmodule.xo
	$(LD) -o $@ $< $(SHOBJ_LDFLAGS) $(LIBS) -lc

clean:
	rm -rf *.xo *.so

=== debian/changelog ===
redis (5:4.0.9-1ubuntu0.2) bionic-security; urgency=medium

  * SECURITY UPDATE: heap buffer overflows in Hyperloglog (Closes: #1836496)
    - debian/patches/CVE-2019-10192.patch: Fix hyperloglog corruption
    - CVE-2019-10192

 -- Julian Andres Klode <juliank@ubuntu.com>  Sun, 14 Jul 2019 21:20:08 +0200

redis (5:4.0.9-1ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Memory corruption
    - debian/patches/CVE-2018-11218.patch: fix in
      deps/lua/src/lua_cmsgpack.c.
    - CVE-2018-11218
  * SECURITY UPDATE: Integer Overflow
    - debian/patches/CVE-2018-11219-*.patch: fix in
      deps/lua/src/lua_struct.c.
    - CVE-2018-11219
  * SECURITY UPDATE: Buffer overflow in the redis-cli
    - debian/patches/CVE-2018-12326.patch: fix in
      redis-cli.c.
    - CVE-2018-12326

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 29 Nov 2018 11:37:34 +0100

redis (5:4.0.9-1) unstable; urgency=medium

  * New upstream release.
  * Refresh all patches.

 -- Chris Lamb <lamby@debian.org>  Mon, 02 Apr 2018 20:37:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: redis
 Section: database
 Priority: optional
-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11~),
  dpkg-dev (>= 1.17.14),
  libjemalloc-dev [linux-any],
  procps <!nocheck>,

=== debian/tests/control ===
Tests: 0001-redis-cli

Tests: 0002-benchmark

Tests: 0003-redis-check-aof

Tests: 0004-redis-check-rdb
Restrictions: needs-root

## redis 4.0.11

=== debian/changelog ===
redis (5:4.0.11-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Thu, 09 Aug 2018 08:50:55 +0200

redis (5:4.0.11-2) unstable; urgency=medium

  * Revert "Move to debhelper-compat (= 11) in Build-Depends." as dak will
    REJECT with "missing-build-dependency debhelper".

 -- Chris Lamb <lamby@debian.org>  Mon, 06 Aug 2018 11:42:41 +0800

redis (5:4.0.11-1) unstable; urgency=medium

  * New upstream release.
    <https://groups.google.com/forum/#!topic/redis-db/aXusvS8da8g>
  * Bump Standards-Version to 4.2.0.
  * Move to debhelper-compat (= 11) in Build-Depends.

 -- Chris Lamb <lamby@debian.org>  Mon, 06 Aug 2018 11:42:38 +0800

redis (5:4.0.10-2) unstable; urgency=medium

  [ Daniel Shahaf ]
  * redis-benchmark(1): Fix default of -n argument. (Closes: #903044)

  [ Chris Lamb ]
  * Add CVE entries to (released) changelog entry.
  * Bump Standards-Version to 4.1.5.

 -- Chris Lamb <lamby@debian.org>  Thu, 05 Jul 2018 22:14:45 +0200

redis (5:4.0.10-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Thu, 14 Jun 2018 08:44:02 +0200

redis (5:4.0.10-1) unstable; urgency=medium

  * CVE-2018-11218, CVE-2018-11219: New upstream security release.
    <https://github.com/antirez/redis/issues/5017> for more information.
    (Closes: #901495)

 -- Chris Lamb <lamby@debian.org>  Thu, 14 Jun 2018 08:37:09 +0200

redis (5:4.0.9-4) unstable; urgency=medium

  * Update Vcs-* headers to point to salsa.debian.org.
  * Move to HTTPS Homepage URI.
  * wrap-and-sort -sa.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 Jun 2018 20:11:35 +0100

redis (5:4.0.9-3) unstable; urgency=medium

  * Make /var/log/redis, etc. owned by root:adm, not root:root. Thanks to
    Thomas Goirand. (Closes: #900496)

 -- Chris Lamb <lamby@debian.org>  Fri, 01 Jun 2018 08:56:48 +0100

redis (5:4.0.9-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 23 May 2018 20:12:11 +0100

redis (5:4.0.9-2) unstable; urgency=medium

  * Ignore test failures on problematic archs.
  * Bump Standards-Version to 4.1.4.

 -- Chris Lamb <lamby@debian.org>  Tue, 08 May 2018 23:08:36 -0700

=== debian/control ===
Source: redis
Section: database
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper (>= 11~),
 dpkg-dev (>= 1.17.14),
 libjemalloc-dev [linux-any],
 procps <!nocheck>,
 tcl <!nocheck>,
Standards-Version: 4.2.0
Homepage: https://redis.io/
Vcs-Git: https://salsa.debian.org/lamby/pkg-redis.git
Vcs-Browser: https://salsa.debian.org/lamby/pkg-redis

Package: redis
Architecture: all
Depends:
 redis-server (<< ${binary:Version}.1~),
 redis-server (>= ${binary:Version}),
 ${misc:Depends},
Description: Persistent key-value database with network interface (metapackage)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.
 .
 This package depends on the redis-server package.

Package: redis-sentinel
Architecture: any
Depends:
 lsb-base (>= 3.2-14),
 redis-tools (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Persistent key-value database with network interface (monitoring)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the Redis Sentinel monitoring software.

Package: redis-server
Architecture: any
Depends:
 lsb-base (>= 3.2-14),
 redis-tools (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Persistent key-value database with network interface
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 The dataset is stored entirely in memory and periodically flushed to disk.

Package: redis-tools
Architecture: any
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 ruby-redis,
Replaces:
 redis-server (<< 2:2.6.16-1),
Breaks:
 redis-server (<< 2:2.6.16-1),
Description: Persistent key-value database with network interface (client)
 Redis is a key-value database in a similar vein to memcache but the dataset
 is non-volatile. Redis additionally provides native support for atomically
 manipulating and querying data structures such as lists and sets.
 .
 This package contains the command line client and other tools.

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 endif
 
 %:
-	dh $@ --with systemd
+	dh $@
 
 override_dh_auto_install:
 	debian/bin/generate-systemd-service-files
@@ -23,13 +23,17 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-ifneq ($(wildcard /usr/bin/taskset),)
 	# Avoid race conditions in upstream testsuite. (#830500)
-	taskset --cpu-list 0 ./runtest
+ifneq (,$(findstring $(DEB_BUILD_ARCH),"mipsel"))
+	# Ignore test failures on problematic archs
+	./runtest --clients 1 || true
+else
+	./runtest --clients 1
+endif
 	# Sentinel integration tests use too many timers to be reliable or
 	# meaningful.
-	taskset --cpu-list 0 ./runtest-sentinel || true
-endif
+	./runtest-cluster || true
+	./runtest-sentinel || true
 endif
 
 override_dh_auto_clean:

## redis 5.0.3

=== debian/changelog ===
redis (5:5.0.3-3~bpo9+2) stretch-backports; urgency=medium

  * Revert to debhelper level 11 for backport otherwise we Pre-Depend on an
    unsatisfiable version of init-system-helpers. (Closes: #918266)

 -- Chris Lamb <lamby@debian.org>  Fri, 04 Jan 2019 21:28:20 +0100

redis (5:5.0.3-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Fri, 04 Jan 2019 12:08:03 +0100

redis (5:5.0.3-3) unstable; urgency=medium

  * Fix FTBFS on hurd-i386 by updating patch to aof.c to avoid MAXPATHLEN
    reference.
  * debian/control:
    - Add missing Pre-Depends on ${misc:Pre-Depends}.
    - Bump Standards-Version to 4.3.0.
  * Bump debhelper compat level to 12.

 -- Chris Lamb <lamby@debian.org>  Tue, 01 Jan 2019 17:47:28 +0000

redis (5:5.0.3-2) unstable; urgency=medium

  * Pass --no-as-needed to ensure linking to the Lua libraries on systems with
    --as-needed as the default. (Closes: #916831)

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Dec 2018 13:18:37 +0000

redis (5:5.0.3-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Fri, 21 Dec 2018 15:37:38 +0000

redis (5:5.0.3-1) unstable; urgency=medium

  * New upstream release.
    - Drop 0009-Don-t-treat-unsupported-protocols-as-fatal-errors.patch as it
      was merged upstream.
    - Refresh all patches.

 -- Chris Lamb <lamby@debian.org>  Tue, 18 Dec 2018 23:48:16 +0000

redis (5:5.0.2-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Thu, 29 Nov 2018 11:07:53 +0100

redis (5:5.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sun, 25 Nov 2018 19:04:10 +0100

redis (5:5.0.1-2) unstable; urgency=medium

  * Refresh patches.
  * Ensure that lack of IPv6 support does not prevent Redis from starting on
    Debian where we bind to the ::1 interface by default. (Closes: #900284,
    #914354)

 -- Chris Lamb <lamby@debian.org>  Fri, 23 Nov 2018 18:03:53 +0100

redis (5:5.0.1-1~bpo9+2) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Revert "Don't use the system hiredis for stretch-backports"; hiredis 0.14.0
    is now in stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Sun, 18 Nov 2018 17:51:49 +0100

redis (5:5.0.1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Chris Lamb <lamby@debian.org>  Wed, 14 Nov 2018 08:32:53 +0100

redis (5:5.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Ensure that Debian-supplied Lua libraries are available using "require"
    during Lua scripting to prevent an issue where we could not use the (eg.)
    cjson library anymore library anymore. This was a regression introduced in
    5:5.0~rc4-3. Thanks to Nicolas Le Manchet <nicolas@lemanchet.fr> for the
    report and testcase. (Closes: #913185)
  * Refer to /run directly in .service files; /var/run is now merely a symlink
    pointing to /run and thus it is now considered best practice to use /run
    directly.
  * debian/rules:
    - Document why we run make in the deps/lua/src directory.
    - Add documentation for LUA_LIBS_{DEBIAN,BUNDLED}.
    - Call $(MAKE) instead of "make".
    - Re-order targets to match usual order.

 -- Chris Lamb <lamby@debian.org>  Sun, 11 Nov 2018 20:09:51 +0100

redis (5:5.0.0-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
    - Don't use the system hiredis for stretch-backports; hiredis is only at
      version 0.13.3-2 in stretch.

 -- Chris Lamb <lamby@debian.org>  Tue, 23 Oct 2018 22:50:26 -0400

redis (5:5.0.0-2) unstable; urgency=medium

  * Update our patch to sentinel.conf to ensure the correct runtime PID file
    location. (Closes: #911407)
  * Listen on ::1 interfaces too for redis-sentinel to match redis-server.
  * Also run the new "LOLWUT" command in the redis-cli autopkgtest.

 -- Chris Lamb <lamby@debian.org>  Fri, 19 Oct 2018 22:36:40 -0400

redis (5:5.0.0-1) unstable; urgency=medium

  * New upstream stable release to unstable.
    <https://groups.google.com/forum/#!topic/redis-db/l0OXDAlwosU>
  * Refresh patches.
  * Update Vcs-Git.

 -- Chris Lamb <lamby@debian.org>  Thu, 18 Oct 2018 21:56:02 -0400

redis (5:5.0~rc5-2) experimental; urgency=medium

  * Use the system hiredis now that #907259 has landed. (Closes: #907258)

 -- Chris Lamb <lamby@debian.org>  Wed, 03 Oct 2018 19:54:17 +0100

redis (5:5.0~rc5-1) experimental; urgency=medium

  * New upstream release.
    - Drop 0004-SOURCE_DATE_EPOCH.patch; merged upstream.
  * debian/watch: Use releases from <https://github.com/antirez/redis/releases>
    (not Git) to find RC/beta releases, etc.

 -- Chris Lamb <lamby@debian.org>  Mon, 24 Sep 2018 21:24:48 +0100

redis (5:5.0~rc4-4) experimental; urgency=medium

  * Stop playing whack-a-mole with nondeterminstic testsuite and run with
    "|| true" on all architectures. (Closes: #908540)
  * Drop ${shlibs:Depends} substvars on "Architecture: any" binary packages.
  * Add upstream URIs for patches to support non-embedded jemalloc and Lua.
  * Bump Standards-Version to 4.2.1.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Sep 2018 19:44:35 +0100

redis (5:5.0~rc4-3) experimental; urgency=medium

  * Add support for (and use) a USE_SYSTEM_LUA flag. (Closes: #901669)
  * Add support for (and use) a USE_SYSTEM_JEMALLOC flag.
  * Refresh 0003-dpkg-buildflags patch.
  * Append "-b debian/experimental" to Vcs-Git line to fix "unpushed changes"
    vcswatch.cgi false-positives.

 -- Chris Lamb <lamby@debian.org>  Sun, 26 Aug 2018 14:37:25 +0200

redis (5:5.0~rc4-2) experimental; urgency=medium

  * Drop a non-determinstic "dump" test.

 -- Chris Lamb <lamby@debian.org>  Tue, 07 Aug 2018 11:04:16 +0800

redis (5:5.0~rc4-1) experimental; urgency=medium

  * New upstream RC release.
    <https://groups.google.com/forum/#!topic/redis-db/aXusvS8da8g>


=== debian/control ===
--- 
+++ 
@@ -3,12 +3,16 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 11),
  dpkg-dev (>= 1.17.14),
+ libhiredis-dev (>= 0.14.0),
  libjemalloc-dev [linux-any],
+ liblua5.1-dev,
+ lua-bitop-dev,
+ lua-cjson-dev,
  procps <!nocheck>,
  tcl <!nocheck>,
-Standards-Version: 4.2.0
+Standards-Version: 4.3.0
 Homepage: https://redis.io/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-redis.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-redis
@@ -30,11 +34,11 @@
 
 Package: redis-sentinel
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends:
  lsb-base (>= 3.2-14),
  redis-tools (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends},
 Description: Persistent key-value database with network interface (monitoring)
  Redis is a key-value database in a similar vein to memcache but the dataset
  is non-volatile. Redis additionally provides native support for atomically
@@ -44,11 +48,11 @@
 
 Package: redis-server
 Architecture: any
+Pre-Depends: ${misc:Pre-Depends}
 Depends:
  lsb-base (>= 3.2-14),
  redis-tools (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends},
 Description: Persistent key-value database with network interface
  Redis is a key-value database in a similar vein to memcache but the dataset
  is non-volatile. Redis additionally provides native support for atomically

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk

# Try and use these Lua modules shipped in Debian...
LUA_LIBS_DEBIAN = cjson bitop

# ... which are not always called their "C" names
LUA_LIBS_DEBIAN_NAMES = cjson bit

# ... but fallback to these currently unpackaged ones.
LUA_LIBS_BUNDLED = struct cmsgpack

LUA_OBJECTS = $(addprefix lua_,$(addsuffix .o,$(LUA_LIBS_BUNDLED)))
LUA_LDFLAGS = $(addprefix -llua5.1-,$(LUA_LIBS_DEBIAN)) $(addprefix ../deps/lua/src/,$(LUA_OBJECTS))

export CFLAGS CPPFLAGS LDFLAGS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-no-as-needed -ldl -latomic $(LUA_LDFLAGS)

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
	export MAKEFLAGS
endif

%:
	dh $@

debian/lua_libs_debian.c:
	echo "// Automatically generated; do not edit." >$@
	echo "luaLoadLib(lua, LUA_LOADLIBNAME, luaopen_package);" >>$@
	set -e; for X in $(LUA_LIBS_DEBIAN_NAMES); do \
		echo "if (luaL_dostring(lua, \"$$X = require('$$X');\"))" >>$@; \
		echo "    serverLog(LL_NOTICE, \"Error loading $$X library\");" >>$@; \
	done
	echo 'luaL_dostring(lua, "module = nil; require = nil;");' >>$@

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/release.h debian/*.service debian/lua_libs_debian.c

override_dh_auto_build: debian/lua_libs_debian.c
	# Build the non-bundled Lua libraries
	$(MAKE) -C deps/lua/src $(LUA_OBJECTS)
	
	dh_auto_build --parallel -- V=1 USE_SYSTEM_JEMALLOC=yes USE_SYSTEM_LUA=yes USE_SYSTEM_HIREDIS=yes

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Avoid race conditions in upstream testsuite.
	./runtest --clients 1 || true
	./runtest-cluster || true
	./runtest-sentinel || true
endif

override_dh_auto_install:
	debian/bin/generate-systemd-service-files

override_dh_compress:
	dh_compress -Xredis-trib.rb

override_dh_installchangelogs:
	dh_installchangelogs --keep 00-RELEASENOTES

## redis 5.0.3.2

=== debian/changelog ===
redis (5:5.0.3.2-1+eagle) unstable; urgency=medium

  * update

 -- Chris Lamb <lamby@debian.org>  Fri, 02 Apr 2021 10:53:46 +0800

redis (5:5.0.3.1-1+security) buster; urgency=medium

  * Non-maintainer upload.
  * update to debian/5.0.3-4+deb10u2

 -- zhouzilong <zhouzilong@uniontech.com>  Fri, 26 Mar 2021 15:51:24 +0800

redis (5:5.0.3-4+deb10u2) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fix integer overflow in embedded lua_struct.c (CVE-2020-14147)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 19 Jul 2020 14:29:02 +0200

redis (5:5.0.3-4+deb10u1) buster-security; urgency=high

  * CVE-2019-10192: Fix two heap buffer overflows in the Hyperloglog
    functionality. (Closes: #931625)
  * CVE-2019-10193: Fix a stack buffer overflow vulnerability in the
    Hyperloglog functionality. (Closes: #931625)

 -- Chris Lamb <lamby@debian.org>  Wed, 10 Jul 2019 14:50:30 -0300

redis (5:5.0.3-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix cross build failure by building the non-bundled Lua libraries via
    dh_auto_build. (Closes: #919682)

 -- Chris Lamb <lamby@debian.org>  Sun, 20 Jan 2019 22:23:41 +0000

## redis 5.0.5

=== debian/changelog ===
redis (5:5.0.5-2build1) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:08:13 +0000

redis (5:5.0.5-2) unstable; urgency=medium

  * Sourceful upload to unstable to ensure testing migration.
  * Bump Standards-Version to 4.4.0.
  * Don't build release tags in gitlab-ci.yml.

 -- Chris Lamb <lamby@debian.org>  Sat, 20 Jul 2019 17:14:37 -0300

redis (5:5.0.5-1) unstable; urgency=medium

  * New upstream release.
    <https://groups.google.com/forum/#!topic/redis-db/jSAtf64lIW4>

 -- Chris Lamb <lamby@debian.org>  Wed, 22 May 2019 10:03:21 +0100

redis (5:5.0.4-1) unstable; urgency=medium

  * New upstream release.
    <https://groups.google.com/forum/#!topic/redis-db/aXusvS8da8g>

 -- Chris Lamb <lamby@debian.org>  Mon, 18 Mar 2019 14:20:46 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper-compat (= 11),
+ debhelper-compat (= 12),
  dpkg-dev (>= 1.17.14),
  libhiredis-dev (>= 0.14.0),
  libjemalloc-dev [linux-any],
@@ -12,7 +12,7 @@
  lua-cjson-dev,
  procps <!nocheck>,
  tcl <!nocheck>,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://redis.io/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-redis.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-redis
